<?php

namespace Drupal\commerce_eta\Event;

use Drupal\commerce_eta\Entity\Trigger;
use Drupal\commerce_order\Entity\Order;
use Drupal\user\UserInterface;
use Symfony\Component\EventDispatcher\Event;

/**
 * Event that is fired when a user logs in.
 */
class OrderEvent extends Event {

  const COMMERCE_ETA_ORDER = 'commerce_eta.order';

  /**
   * @var \Drupal\commerce_eta\Entity\Trigger
   */
  protected $trigger;

  /**
   * @var \Drupal\commerce_order\Entity\Order
   */
  protected $order;

  /**
   * @var integer
   */
  protected $run_count;

  /**
   * Constructs the object.
   *
   * @param \Drupal\user\UserInterface $account
   *   The account of the user logged in.
   */
  public function __construct(Trigger $trigger, Order $order, $run_count = NULL) {
    $this->trigger = $trigger;
    $this->order = $order;
    $this->run_count = $run_count;
  }

  public function getOrder() {
    return $this->order;
  }

  public function getTrigger() {
    return $this->trigger;
  }

  public function getRunCount() {
    return $this->run_count;
  }

}
